module Stack(clk, we, wrAddr, wrData, rdAddr_A, rdAddr_B, rdData_A, rdData_B, addr);

input clk;
input we;
input [3:0] wrAddr;
input [11:0] wrData;
input [3:0] rdAddr_A, rdAddr_B;

output [11:0] rdData_A, rdData_B;
output [3:0] addr;

reg [11:0] rdData_A, rdData_B;
reg [3:0] addr;

reg [191:0] stack;

always @ (posedge clk) begin
  if (we) begin 

	  if (wrAddr == 0) stack[11:0] <= wrData;
	  else if (wrAddr == 1) stack[23:12] <= wrData;
	  else if (wrAddr == 2) stack[35:24] <= wrData;
	  else if (wrAddr == 3) stack[47:36] <= wrData;
	  else if (wrAddr == 4) stack[59:48] <= wrData;
	  else if (wrAddr == 5) stack[71:60] <= wrData;
	  else if (wrAddr == 6) stack[83:72] <= wrData;
	  else if (wrAddr == 7) stack[95:84] <= wrData;
	  else if (wrAddr == 8) stack[107:96] <= wrData;
	  else if (wrAddr == 9) stack[119:108] <= wrData;
	  else if (wrAddr == 10) stack[131:120] <= wrData;
	  else if (wrAddr == 11) stack[143:132] <= wrData;
	  else if (wrAddr == 12) stack[155:144] <= wrData;
	  else if (wrAddr == 13) stack[167:156] <= wrData;
	  else if (wrAddr == 14) stack[179:168] <= wrData;
	  else if (wrAddr == 15) stack[191:180] <= wrData;
  end
  
  if (rdAddr_A == 0) rdData_A <= stack[11:0];
  else if (rdAddr_A == 1) rdData_A <= stack[23:12] ;
  else if (rdAddr_A == 2) rdData_A <= stack[35:24] ;
  else if (rdAddr_A == 3) rdData_A <= stack[47:36] ;
  else if (rdAddr_A == 4) rdData_A <= stack[59:48] ;
  else if (rdAddr_A == 5) rdData_A <= stack[71:60] ;
  else if (rdAddr_A == 6) rdData_A <= stack[83:72] ;
  else if (rdAddr_A == 7) rdData_A <= stack[95:84] ;
  else if (rdAddr_A == 8) rdData_A <= stack[107:96] ;
  else if (rdAddr_A == 9) rdData_A <= stack[119:108] ;
  else if (rdAddr_A == 10) rdData_A <= stack[131:120] ;
  else if (rdAddr_A == 11) rdData_A <= stack[143:132] ;
  else if (rdAddr_A == 12) rdData_A <= stack[155:144] ;
  else if (rdAddr_A == 13) rdData_A <= stack[167:156] ;
  else if (rdAddr_A == 14) rdData_A <= stack[179:168] ;
  else if (rdAddr_A == 15) rdData_A <= stack[191:180] ;

  if (we) begin
    rdData_B <= wrData;
  end
  else begin
	  if (rdAddr_B == 0) rdData_B <= stack[11:0];
	  else if (rdAddr_B == 1) rdData_B <= stack[23:12] ;
	  else if (rdAddr_B == 2) rdData_B <= stack[35:24] ;
	  else if (rdAddr_B == 3) rdData_B <= stack[47:36] ;
	  else if (rdAddr_B == 4) rdData_B <= stack[59:48] ;
	  else if (rdAddr_B == 5) rdData_B <= stack[71:60] ;
	  else if (rdAddr_B == 6) rdData_B <= stack[83:72] ;
	  else if (rdAddr_B == 7) rdData_B <= stack[95:84] ;
	  else if (rdAddr_B == 8) rdData_B <= stack[107:96] ;
	  else if (rdAddr_B == 9) rdData_B <= stack[119:108] ;
	  else if (rdAddr_B == 10) rdData_B <= stack[131:120] ;
	  else if (rdAddr_B == 11) rdData_B <= stack[143:132] ;
	  else if (rdAddr_B == 12) rdData_B <= stack[155:144] ;
	  else if (rdAddr_B == 13) rdData_B <= stack[167:156] ;
	  else if (rdAddr_B == 14) rdData_B <= stack[179:168] ;
	  else if (rdAddr_B == 15) rdData_B <= stack[191:180];
  end	  
  
  addr <= rdAddr_B; 

end
        
endmodule

