------------------------------------------------------
-- LogiBLOX ROM Module "im"
-- Created by LogiBLOX version D.24
--    on Mon Mar 05 18:36:31 2001
-- Attributes 
--    MODTYPE = ROM
--    BUS_WIDTH = 4
--    DEPTH = 32
--    MEMFILE = temp
--    TRIM = FALSE
--    STYLE = MAX_SPEED
--    USE_RPM = FALSE
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY im IS
  PORT(
    A: IN std_logic_vector(4 DOWNTO 0);
    DO: OUT std_logic_vector(3 DOWNTO 0));
END im;

-- synopsys translate_off
ARCHITECTURE sim OF im IS
  SIGNAL START_PULSE: std_logic := '1';
  TYPE mem_data IS ARRAY (31 DOWNTO 0) OF std_logic_vector(3 DOWNTO 0);
BEGIN
  PROCESS
  VARIABLE VD: mem_data;
  VARIABLE first_time: BOOLEAN := TRUE;
  BEGIN
    IF (first_time) THEN
      VD(0) := ('0','0','0','0');
      VD(1) := ('0','0','0','0');
      VD(2) := ('0','0','0','0');
      VD(3) := ('0','0','0','0');
      VD(4) := ('0','0','0','0');
      VD(5) := ('0','0','0','0');
      VD(6) := ('0','0','0','0');
      VD(7) := ('0','0','0','0');
      VD(8) := ('0','0','0','0');
      VD(9) := ('0','0','0','0');
      VD(10) := ('0','0','0','0');
      VD(11) := ('0','0','0','0');
      VD(12) := ('0','0','0','0');
      VD(13) := ('0','0','0','0');
      VD(14) := ('0','0','0','0');
      VD(15) := ('0','0','0','0');
      VD(16) := ('0','0','0','0');
      VD(17) := ('0','0','0','0');
      VD(18) := ('0','0','0','0');
      VD(19) := ('0','0','0','0');
      VD(20) := ('0','0','0','0');
      VD(21) := ('0','0','0','0');
      VD(22) := ('0','0','0','0');
      VD(23) := ('0','0','0','0');
      VD(24) := ('0','0','0','0');
      VD(25) := ('0','0','0','0');
      VD(26) := ('0','0','0','0');
      VD(27) := ('0','0','0','0');
      VD(28) := ('0','0','0','0');
      VD(29) := ('0','0','0','0');
      VD(30) := ('0','0','0','0');
      VD(31) := ('0','0','0','0');
      first_time := FALSE;
    END IF;
    IF (mvlvec_not01(A)) THEN
      DO <= ('X','X','X','X');
    ELSIF (mvlvec2int(A) > 31) THEN
      ASSERT (FALSE)
      REPORT "The value on the address line is out of range"
      SEVERITY WARNING;
      DO <= ('X','X','X','X');
    ELSE
      DO <= VD(mvlvec2int(A));
    END IF;
      WAIT ON A, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
